require 'An.lua'

function love.load() 
  x = 0
  count = 0 
  stime = love.timer.getTime()  
  world = love.physics.newWorld(-1250, -6500, 1250, 6500)  
  world:setMeter(64) --the height of a meter in this world will be 64px
  start = love.graphics.newImage("start.png")
  startx = 1250/2
  starty = 425
  local img  = love.graphics.newImage("mhsc.png")
  local img2  = love.graphics.newImage("mhsc 2.png")
  local img3  = love.graphics.newImage("mhrc 1.png")
  local img4  = love.graphics.newImage("mhrc 2.png")
  local img5  = love.graphics.newImage("mhrc 3.png")
  local img6  = love.graphics.newImage("mhrc 4.png")
  local img7  = love.graphics.newImage("countdown.png")
  anim = newAnimation(img, 42, 108, 0.3, 0)
  anim2 = newAnimation(img2, 42, 108, 0.3, 0)
  anim3 = newAnimation(img3, 42, 109, 0.2, 0)
  anim4 = newAnimation(img4, 42, 109, 0.2, 0)
  anim5 = newAnimation(img5, 42, 109, 0.2, 0)
  anim6 = newAnimation(img6, 42, 109, 0.2, 0)
  anim7 = newAnimation(img7, 27, 34, 0.1, 0)

  bodies = {}
  shapes = {}
  
  --let's create the ground
  --we need to give the ground a mass of zero so that the ground wont move
  bodies[0] = love.physics.newBody(world, 650/2, 925, 0, 0) 
  shapes[0] = love.physics.newRectangleShape(bodies[0], 0, 0, 6500, 50, 0)
  
  --let's create a ball
  bodies[1] = love.physics.newBody(world, 125, 846, 40, 0) 
  shapes[1] = love.physics.newRectangleShape(bodies[1], 0, 0, 42, 108, 0) 
  
  bodies[2] = love.physics.newBody(world, 650/2, 25, 0, 0) 
  shapes[2] = love.physics.newRectangleShape(bodies[2], 0, 0, 6500, 50, 0)

  bodies[3] = love.physics.newBody(world, -25, 950/2, 0, 0) 
  shapes[3] = love.physics.newRectangleShape(bodies[3], 0, 0, 50, 6500, 0)

  bodies[4] = love.physics.newBody(world, 1275, 950/2, 0, 0) 
  shapes[4] = love.physics.newRectangleShape(bodies[4], 0, 0, 50, 6500, 0)
 

--initial graphics setup
  love.graphics.setBackgroundColor(250, 250, 250) 
  love.graphics.setMode(1250, 950, false, true, 0) 
end



function love.update(dt)
  Gtime = love.timer.getTime()*x
  etime = love.timer.getTime()
  world:update(dt) --this puts the world into motion
  anim:update(dt)
  anim2:update(dt)
  anim3:update(dt)
  anim4:update(dt)
  anim5:update(dt)
  anim6:update(dt)
  anim7:update(dt)
  --here we are going to create some keyboard even
  if love.keyboard.isDown("right") and startx < -100  then 
    bodies[1]:applyForce(700, 0)
    local x, y =world:getGravity()       
    world:setGravity(2, y)
  elseif love.keyboard.isDown("left") and startx < -100  then 
    bodies[1]:applyForce(-700, 0) 
    local x, y =world:getGravity()
    world:setGravity(-1, y)
end



function love.keypressed( key, unicode )	
     if key == "down" and startx < -100 then
      local e, n =bodies[1]:getPosition()
      bodies[1]:setPosition(e, (n-950)*-1)
      local x, y =world:getGravity()
      world:setGravity(1, -y) 
      count = count + 1
     elseif key == "up" and startx < -100 then
      local e, n =bodies[1]:getPosition()
      bodies[1]:setPosition(e, (n-950)*-1)
      local x, y =world:getGravity()
      world:setGravity(1, -y)
      count = count + 1
     elseif key == " " and etime-stime > .1 then
      local x, y =world:getGravity()
      bodies[1]:applyImpulse(0, -y/2.86)
     elseif key == "ralt" then
       local x, y =world:getGravity()
        world:setGravity(x, -y)
       bodies[1]:applyImpulse(0, -y*1.5)
       count = count + 1
     elseif key == "return" then
          love.filesystem.load("main2.lua")()
		love.load()   
            startx = -1000
            starty = -1000
            world:setGravity(1, 1000)
            x = 1            
      elseif key == "escape" then
           love.filesystem.load("main.lua")()
		love.load()
     end
end

function love.keyreleased( key, unicode )
     if key == " " then
      local x, y =world:getGravity()
      bodies[1]:applyImpulse(0, y/5)
      stime = love.timer.getTime()
     elseif key == "right" then
     local x, y =world:getGravity()
     world:setGravity(1, y)
     elseif key == "left" then
     local x, y =world:getGravity()
     world:setGravity(1, y)
   end
end

    -- Update the world.
    world:update(dt)
end

function newPaddedImage(filename)
    local source = love.image.newImageData(filename)
    local w, h = source:getWidth(), source:getHeight()
    
    -- Find closest power-of-two.
    local wp = math.pow(2, math.ceil(math.log(w)/math.log(2)))
    local hp = math.pow(2, math.ceil(math.log(h)/math.log(2)))
    
    -- Only pad if needed:
    if wp ~= w or hp ~= h then
        local padded = love.image.newImageData(wp, hp)
        padded:paste(source, 0, 0)
        return love.graphics.newImage(padded)
    end
    
    return love.graphics.newImage(source)
end


function love.draw()
  love.graphics.draw(start, startx, starty)
  local x1, y1, x2, y2, x3, y3, x4, y4 = shapes[0]:getBoundingBox() 
  --x1, y1 represent the bottom left corner of the bounding box
  --x2, y2 represent the top left corner of the bounding box
  --x3, y3 represent the top right corner of the bounding box
  --x4, y4 represent the top right corner of the boudning box
  local boxwidth = x3 - x2 --calculate the width of the box
  local boxheight = y2 - y1 --calculate the height of the box
  love.graphics.setColor(0, 0, 0) --set the drawing color to green for the ground
  --the rectangle is drawing from the top left corner
  --so we need to compensate for that
  love.graphics.rectangle("fill", bodies[0]:getX() - boxwidth/2, bodies[0]:getY() - boxheight/2, boxwidth, boxheight)
  love.graphics.rectangle("fill", bodies[2]:getX() - boxwidth/2, bodies[2]:getY() - boxheight/2, boxwidth, boxheight)
  love.graphics.rectangle("fill", bodies[3]:getX() - boxwidth/2, bodies[3]:getY() - boxheight/2, boxheight, boxwidth)
  love.graphics.rectangle("fill", bodies[4]:getX() - boxwidth/2, bodies[4]:getY() - boxheight/2, 50, 100)
  love.graphics.setColor(0, 0, 0) --set the drawing color to red for the ball
  --the circle is drawing from the center
  --so we do not need to compensate
  love.graphics.setColor(250, 250, 250)
  love.graphics.setFont(font["small"])
  love.graphics.print("Press The Space Bar To Jump  ", 20, 20)
  love.graphics.print("Par: 3   Current:"..count.."   ", 1050, 20)
  love.graphics.print("Time:"..Gtime.."  ", 1050, 40)
  anim:draw(bodies[1]:getX()-21, bodies[1]:getY()-54)
 local x, y =world:getGravity()
   if x == 1 and y < -100 then
   anim2:draw(bodies[1]:getX()-21, bodies[1]:getY()-54)
   elseif x < 0 and y > 100 then
   anim3:draw(bodies[1]:getX()-21, bodies[1]:getY()-55)
   elseif x > 1 and y > 100 then
   anim4:draw(bodies[1]:getX()-21, bodies[1]:getY()-55)
   elseif x < 0 and y < -100 then
   anim5:draw(bodies[1]:getX()-21, bodies[1]:getY()-54)
   elseif x > 1 and y < -100 then
   anim6:draw(bodies[1]:getX()-21, bodies[1]:getY()-54)
    --anim7:draw(1000, 12)
   end
end